<html>
<head>
<!-- Tocas UI：CSS 與元件 -->
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/tocas-ui/2.3.3/tocas.css">
<!-- Tocas JS：模塊與 JavaScript 函式 -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/tocas-ui/2.3.3/tocas.js"></script>
<script src="../script/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/pressure/2.1.2/jquery.pressure.min.js"></script>
<script src="../script/ao_module.js"></script>
<meta name="viewport" content="width=device-width; initial-scale=1.0; maximum-scale=1.0; user-scalable=0;">
<script
  src="https://code.jquery.com/ui/1.12.1/jquery-ui.min.js"
  integrity="sha256-VazP97ZCwtekAsvgPBSUwPFKdrwD3unUfSGVYrahUqU="
  crossorigin="anonymous"></script>
</head>
<body>
<div class="ts menu" style="position: absolute;width: 100vw;z-index: 2;">
    <a class="item" onclick="save();">Save</a>
    <a class="item" onclick="importimg();">Import</a>
	<a class="item" id="mode" onclick="chgmode()">Normal</a>
	<div class="right menu">
        <a onclick="undo()" class="item">Undo</a>
        <a onclick="redo()" class="item">Redo</a>
    </div>
</div>
<img id="moveableimage" style="position: absolute;z-index:1"></img>
<canvas id="paintArea" width="100" height="100"></canvas>

<div style="position: fixed;bottom: 0;right: 0;">
	<div style="bottom: 5px;right: 5px;display: block;float: left;" id="colorselector">
		<div class="ts slider" style="margin-right: 10px;float: right;">
			<input id="width" type="range">
		</div>
	</div>
</div>
<div class="ts modals dimmer">
    <dialog id="optionModal" class="ts modal">
        <div class="header">
            Save as
        </div>
        <div class="content">
				<div class="ts form">

					<div class="field">
						<div class="ts labeled input" style="width:100%">
							<div class="ts label">
								/AOR/
							</div>
							<input type="text" id="path" placeholder="Enter path and filename here">
							<button class="ts icon button" onClick="selectFolder();">
								<i class="folder open icon"></i>
							</button>
						</div>
					</div>
				</div>
        </div>
        <div class="actions">
            <button class="ts deny button">
                Cancel
            </button>
            <button class="ts positive button" onclick="f_ok()">
                Save
            </button>
        </div>
    </dialog>
</div>
<div class="ts bottom right snackbar">
		<div class="content"></div>
	</div>
</body>
<script type="text/javascript">
var canvas = document.getElementById("paintArea");
var ctx = canvas.getContext('2d');
var clicking = false;

var width = 0;
ts('.ts.slider').slider();

var currHeight = window.innerHeight;
var currWidth = window.innerWidth;
$("#paintArea")[0].width = window.innerWidth;
$("#paintArea")[0].height = window.innerHeight;

var action = [];
var curractionid = -1;
var hasunredo = false; // which indicates if user has done a redo or undo before touchdown
addaction();

var color = ['#ff0000', '#ff8c00', '#fff600', '#00ff6e', '#00ffae', '#3b00ff', '#ae00ff', '#000000'];
color.forEach(function(element) {
  $("#colorselector").prepend('<div class="cp" style="background-color: ' + element + ';width: 30px;height: 30px;border-radius: 50%;float: right;margin-right: 4px;" data-color="' + element + '" onclick="chgcolor(this)"></div>');
});
$( ".cp[data-color~='#000000']" ).html('<i style="margin-left: 24%;margin-top: 24%;" class="checkmark icon"></i>');
function chgcolor(element){
	ctx.strokeStyle = $(element).attr("data-color");
	$(".cp").html("");
	$(element).html('<i style="margin-left: 24%;margin-top: 24%;" class="checkmark icon"></i>');
}

var pmode = false;
function chgmode(){
	if(pmode){
		pmode = false;
		$("#mode").html("Normal");
	}else{
		pmode = true;
		$("#mode").html("Pressure");
	}
}
$('#paintArea').pressure({
  change: function(f, event){
		if(pmode){
			width = f * 10;
			$("#width").attr("style","background-image: -webkit-gradient(linear, 0% 0%, 100% 0%, color-stop(" + width/10 + ", rgb(150, 150, 150)), color-stop(" + width/10 + ", rgb(233, 233, 233)));");
			$("#width").val(width * 10);
			console.log(width);
		}
  },
});


$(window).on('resize', function () {
	var currImg = ctx.getImageData(0, 0, currWidth, currHeight);	
	currWidth = window.innerWidth;
	currHeight = window.innerHeight;		
	$("#paintArea")[0].width = window.innerWidth;
	$("#paintArea")[0].height = window.innerHeight;
	ctx.putImageData(currImg, 0, 0);
});

var prevX = 0;
var prevY = 0;
$( "#paintArea" ).on('mousedown touchstart',function(e) {
    
	if(hasunredo){
		cleanaction();
	}
    
    console.log(e.pageX, e.pageY);
	clicking = true;
	if(!pmode){
		ctx.beginPath();
		ctx.moveTo(e.pageX,e.pageY);
	}
	prevX = e.pageX;
	prevY = e.pageY;
});

$( "#paintArea" ).on('mousemove touchmove',function(e) {
	if(clicking){
		if(pmode){
			ctx.beginPath();
			ctx.moveTo(prevX,prevY);
		}
		ctx.lineWidth = width;
		console.log(e.pageX, e.pageY);
		ctx.lineTo(e.pageX,e.pageY);
		ctx.stroke();
		
		prevX = e.pageX;
		prevY = e.pageY;
	}
});

$( "#paintArea" ).on('mouseup touchend',function(e) {
	clicking = false;
	addaction();
});

$("#width").on('change', function () {
	width = $("#width").val() / 10;
});

function cleanaction(){
	action.splice(curractionid + 1, action.length -1); 
}

function addaction(){
    var currImg = ctx.getImageData(0, 0, currWidth, currHeight);
	console.log(currWidth + " , " + currHeight);
    action.push(currImg);
    curractionid = curractionid + 1;
}

function undo(){
	if(curractionid > 0){
		curractionid = curractionid - 1;
		console.log(curractionid);
		ctx.putImageData(action[curractionid], 0, 0);
	}else{
		msgbox("Nothing to undo.","","");
	}
	hasunredo = true;
}

function redo(){
	if(curractionid < action.length - 1){
		curractionid = curractionid + 1;
		ctx.putImageData(action[curractionid], 0, 0);
	}else{
		msgbox("Nothing to redo.","","");
	}
	hasunredo = true;
}

function save(){
	ts('#optionModal').modal("show");
}

function importimg(){
	if (ao_module_virtualDesktop){
		ao_module_openFileSelector(Math.round(Math.random()*100,0),"importselector",undefined,undefined,false,"file");
	}else{
		ao_module_openFileSelectorTab(Math.round(Math.random()*100,0),"../",false,"file",importselector);
	}	
}

var filepath = "";
function importselector(object){
	var files = JSON.parse(object);
	console.log(files);
	filepath = "../" + files[0].filepath;
	$("#moveableimage").attr("src","../" + files[0].filepath);
	$("#moveableimage").draggable();
	$(".ts.menu").html('<a class="item" onclick="confirmimport();">OK</a><a class="item" onclick="cancelimport();">Cancel</a><div class="right menu"> <a onclick="zin()" class="item">Zoom in</a> <a onclick="zout()" class="item">Zoom out</a></div></div>');
}

function confirmimport(){
	if(hasunredo){
		cleanaction();
	}
	
	var img = new Image();
	img.onload = function() {
		var ctx = document.getElementById('paintArea').getContext('2d');
		var top = $("#moveableimage").position()["top"];
		var left = $("#moveableimage").position()["left"];
		console.log(top + " " + left);
		ctx.drawImage(img, left, top, $("#moveableimage").width(), $("#moveableimage").height());
		msgbox("Imported /AOR/" + filepath);
		addaction();
		cancelimport();
	}
	img.src = filepath;
}

function cancelimport(){
	$(".ts.menu").html('<div class="ts menu" style="position: absolute;width: 100vw;z-index: 2;"> <a class="item" onclick="save();">Save</a> <a class="item" onclick="importimg();">Import</a> <a class="item" id="mode" onclick="chgmode()">Normal</a> <div class="right menu"> <a onclick="undo()" class="item">Undo</a> <a onclick="redo()" class="item">Redo</a> </div> </div>');
	$("#moveableimage").removeAttr("src");
	$("#moveableimage").removeAttr("style");
	$("#moveableimage").removeAttr("class");
	$("#moveableimage").attr("style","position: absolute;z-index:1");
}

function zin(){
	$("#moveableimage").height($("#moveableimage").height() * 1.1);
}

function zout(){
	$("#moveableimage").height($("#moveableimage").height() * 0.9);
}

function msgbox(content){
	ts('.snackbar').snackbar({
		content: content,
		onAction: () => {
			$(".snackbar").removeAttr("style");
		}
	});
}

function preventPullToRefresh(element) {
    var prevent = false;

    document.querySelector(element).addEventListener('touchstart', function(e){
      if (e.touches.length !== 1) { return; }

      var scrollY = window.pageYOffset || document.body.scrollTop || document.documentElement.scrollTop;
      prevent = (scrollY === 0);
    });

    document.querySelector(element).addEventListener('touchmove', function(e){
      if (prevent) {
        prevent = false;
        e.preventDefault();
      }
    });
  }

preventPullToRefresh('#paintArea'); // pass #id or html tag into the method


//from 7z
function f_ok(){
	if($("#path").val() == ""){
		msgbox("You can't save to AOR");
	}else{
		$.post("save.php", { b64: $("#paintArea")[0].toDataURL('image/png'), path: $("#path").val()},
		   function(data){
			 msgbox("Saved as " + data);
	   });
	}
}
function getUUID(){
	return new Date().getTime();
}
function selectFolder(){
	if (ao_module_virtualDesktop){
		ao_module_openFileSelector(getUUID(),setPathBySelector,undefined,undefined,false,"folder");
	}else{
		ao_module_openFileSelectorTab(getUUID(),"../",false,"folder",setPathBySelector);
	}
}
function setPathBySelector(object){
	var files = JSON.parse(object);
	console.log(files);
	$("#path").val(files[0].filepath);
}

</script>
</html>